<?php
/**
* @copyright		Copyright (C) 2010 David Bigagli. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
*/

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgContentLoadModuleBetweenArticle extends JPlugin
{
	var $bc_position = array();
	var $bc_start = 0;
	var $bc_jump = 0;
	var $numarticolo = 0;
	var $numbanner = 0;
	var $numjump = 0;
	var $maxtipobanner = 10;
	var $idxtipo = 0;
	var $enabled = 0;


	function plgContentLoadModuleBetweenArticle( &$subject, $params )
	{
//echo "<br><br>plgContentLoadModuleBetweenArticle - plgContentLoadModuleBetweenArticle()<br><br>";
		parent::__construct( $subject, $params );

		for ( $i = 1; $i<=$this->maxtipobanner; $i++ )
			if ( $this->params->get( "bc_position$i" ) )
				$this->bc_position[$i] = $this->params->get( "bc_position$i" );

		$this->bc_jump = (int) $this->params->get( "bc_jump" );
		$this->numjump = $this->bc_jump;
		$this->bc_start = (int) $this->params->get( "bc_start" );
		$this->enabled = (int) $this->params->get( "enabled" );
		$this->style = (int) $this->params->get( "style" );
		if ( $this->bc_start == 0 ) $this->bc_start = 1;
	}

	function onAfterDisplayContent( &$article, &$params, $limitstart )
	{
	        global $mainframe;
//echo "<br><br>plgContentLoadModuleBetweenArticle - onAfterDisplayContent()<br><br>";

	        $view = JRequest::getCmd('view');

		$this->numarticolo++;
	        $content = '';

		if ( count( $this->bc_position ) == 0 or $this->enabled == 0 )
			return $content;

		/* Se nel contenuto dell'articolo è presente la stringa {bannercomponent off} non visualizza il banner */
		if ( strpos( $article->introtext, "{loadmodulebetweenarticle off}" ) !== false or strpos( $article->fulltext, "{loadmodulebetweenarticle off}" ) !== false  )
		{
			$this->clear($article, true);
			return $content;
		}

		/**
			TODO implementare parametro per visualizzare solo in prima pagina o anche in una sezione a scelta
		*/
		if ($view == 'frontpage' or $view == 'section' ) {
			if ( $this->numarticolo >= $this->bc_start ) 
			{
				// Non stampa il banner se è impostato il salto
				if ( $this->numjump != $this->bc_jump )
				{
					$this->numjump++;
					return $content;
				}
				else
					$this->numjump = 0;

				$this->numbanner++;

				ob_start();
				echo '<div class="bannercomponent">';
				echo $this->plgContentLoadPosition( $this->getPosition(), $this->style );
				echo '</div>';
				$content = ob_get_contents();
				ob_end_clean(); 
			}
		}
		return $content;
	}


	function onBeforeDisplayContent( &$article, &$params, $limitstart )
	{
	        global $mainframe;
//echo "<br><br>plgContentLoadModuleBetweenArticle - onBeforeDisplayContent()<br><br>";
	        $view = JRequest::getCmd('view');

	        $content = '';

		if ( count( $this->bc_position ) == 0 or $this->enabled == 0 ) 
			return $content;

		/* Se nel contenuto dell'articolo è presente la stringa {bannercomponent off} non visualizza il banner */
		if ( strpos( $article->introtext, "{loadmodulebetweenarticle off}" ) !== false or strpos( $article->fulltext, "{loadmodulebetweenarticle off}" ) !== false  )
		{
			$this->clear($article, true);
			return $content;
		}

		/**
			TODO implementare parametro per visualizzare solo in prima pagina o anche in una sezione a scelta
		*/
		if ($view == 'frontpage' or $view == 'section' ) {
			if ( $this->numarticolo == 0 and $this->bc_start == -1 ) 
			{
				$this->numbanner++;
				$this->numjump = 0;

				ob_start();
				echo '<div class="bannercomponent">';
				echo $this->plgContentLoadPosition( $this->getPosition(), $this->style );
				echo '</div>';
				$content = ob_get_contents();
				ob_end_clean(); 
			}
		}
		return $content;
	}

	function getPosition( )
	{
		$this->idxtipo++;
		if ( $this->idxtipo > $this->maxtipobanner )
			$this->idxtipo = 1;

		$tipo = $this->bc_position[$this->idxtipo];

		if ( !$tipo )
		{
			$tipo = $this->bc_position[1];
			$this->idxtipo = 2;
		}

		return $tipo;
	}


	/**
	 *
	 * @access private
	 * @param object $row The content item object
	 * @param array $patterns
	 * @param array $replacements
	 * @param boolean $fromText Process 'text' field or introtext/fulltext fields?
	 * @return void
	 */
	function _processTags( &$row, $patterns = array(), $replacements = array(), $fromText = true )
	{
		if (count($patterns) > 0) {
			ob_start();
			if (true == $fromText) {
				$row->text = preg_replace($patterns, $replacements, $row->text);
			} else {
				if (isset($row->introtext)) {
					$row->introtext = preg_replace($patterns, $replacements, $row->introtext);
				}
				if (isset($row->fulltext)) {
					$row->fulltext = preg_replace($patterns, $replacements, $row->fulltext);
				}
			}
			ob_end_clean();
		}
	}

	/**
	 * Clears all JComments tags from content item
	 *
	 * @static
	 * @access public 
	 * @param object $row Content object
	 * @param boolean $fromText Look field 'text' or 'introtext' & 'fulltext'
	 * @return void
	 */
	function clear( &$row, $fromText = false )
	{
		$patterns = array('/{loadmodulebetweenarticle\s+(off)}/is');
		$replacements = array('');
		
		$this->_processTags($row, $patterns, $replacements, $fromText);
	}


	function plgContentLoadPosition( $position, $style=-2 )
	{
		$document	= &JFactory::getDocument();
		$renderer	= $document->loadRenderer('module');
		$params		= array('style'=>$style);

		$contents = '';
		foreach (JModuleHelper::getModules($position) as $mod)  {
			$contents .= $renderer->render($mod, $params);
		}
		return $contents;
	}

}
?>
